<html>
<head>
<title>OGRE: Ogre::EdgeListBuilder Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1EdgeListBuilder.html">EdgeListBuilder</a></div>
<h1>Ogre::EdgeListBuilder Class Reference</h1><!-- doxytag: class="Ogre::EdgeListBuilder" -->General utility class for building edge lists for geometry.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1EdgeListBuilder-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#cf52bd519947f6f8305df1bec3247dd2">EdgeListBuilder</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#f699fd3c27f017e3625b93182dfba122">~EdgeListBuilder</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#9845e2f91660819164a627c661f5d107">addVertexData</a> (const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *vertexData)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add a set of vertex geometry data to the edge builder.  <a href="#9845e2f91660819164a627c661f5d107"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#e4af3550dfe4948680078a087377bfbf">addIndexData</a> (const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *indexData, size_t vertexSet=0, <a class="el" href="classOgre_1_1RenderOperation.html#7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a> opType=RenderOperation::OT_TRIANGLE_LIST)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add a set of index geometry data to the edge builder.  <a href="#e4af3550dfe4948680078a087377bfbf"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#7233d617fe953b3b6c74035636f1d9f0">build</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Builds the edge information based on the information built up so far.  <a href="#7233d617fe953b3b6c74035636f1d9f0"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#66aa1d48de5385be8233c8733af99186">log</a> (<a class="el" href="classOgre_1_1Log.html">Log</a> *l)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Debugging method.  <a href="#66aa1d48de5385be8233c8733af99186"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#54baa37e788c26e4017fdef47c8386dc">VertexDataList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#78243f2c2c6a3cbe263b6c6d802ccf75">GeometryList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html">CommonVertex</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#792974e67a72693e08c7a3c45ca4e06c">CommonVertexList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; <a class="el" href="classOgre_1_1Vector3.html">Vector3</a>, size_t,<br>
 <a class="el" href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html">vectorLess</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#41ee224abb216f7c8bc5261609049d19">CommonVertexMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map for identifying common vertices.  <a href="#41ee224abb216f7c8bc5261609049d19"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef <br>
std::multimap<br>
&lt; std::pair&lt; size_t,<br>
 size_t &gt;, std::pair<br>
&lt; size_t, size_t &gt; &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#76064f6b787a7b561cfac42c32d15879">EdgeMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Edge map, used to connect edges.  <a href="#76064f6b787a7b561cfac42c32d15879"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#931b3ad77134a61a22a64492fdb898bf">buildTrianglesEdges</a> (const <a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a> &amp;geometry)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#dfa93b810bd70c02bc04899851677e52">findOrCreateCommonVertex</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;vec, size_t vertexSet, size_t indexSet, size_t originalIndex)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Finds an existing common vertex, or inserts a new one.  <a href="#dfa93b810bd70c02bc04899851677e52"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#5ea7b21ba4d92d2d9a73c0ac8e2d11ce">connectOrCreateEdge</a> (size_t vertexSet, size_t triangleIndex, size_t vertIndex0, size_t vertIndex1, size_t sharedVertIndex0, size_t sharedVertIndex1)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Connect existing edge or create a new edge - utility method during building.  <a href="#5ea7b21ba4d92d2d9a73c0ac8e2d11ce"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#78243f2c2c6a3cbe263b6c6d802ccf75">GeometryList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#5d4989a248aa1f8fc2f42d278aa708f0">mGeometryList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#54baa37e788c26e4017fdef47c8386dc">VertexDataList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#c706c9ac2d689aa08556ba824386c97a">mVertexDataList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#792974e67a72693e08c7a3c45ca4e06c">CommonVertexList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#2b2c21a40cd9ce67461bd0164fe67a35">mVertices</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#8cc80f94959971521a82cc930cac46e9">mEdgeData</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#41ee224abb216f7c8bc5261609049d19">CommonVertexMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#43c5862bbe8afebf7ca473fbcbf219e0">mCommonVertexMap</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#76064f6b787a7b561cfac42c32d15879">EdgeMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#49964dbb7e73349bed694df63ec9b372">mEdgeMap</a></td></tr>

<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html">CommonVertex</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A vertex can actually represent several vertices in the final model, because vertices along texture seams etc will have been duplicated.  <a href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A set of indexed geometry data.  <a href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1EdgeListBuilder_1_1geometryLess.html">geometryLess</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Comparator for sorting geometries by vertex set.  <a href="structOgre_1_1EdgeListBuilder_1_1geometryLess.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html">vectorLess</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Comparator for unique vertex list.  <a href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html#_details">More...</a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
General utility class for building edge lists for geometry. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You can add multiple sets of vertex and index data to build and edge list. Edges will be built between the various sets as well as within sets; this allows you to use a model which is built from multiple SubMeshes each using separate index and (optionally) vertex data and still get the same connectivity information. It's important to note that the indexes for the edge will be constrained to a single vertex buffer though (this is required in order to render the edge). </dd></dl>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00157">157</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="54baa37e788c26e4017fdef47c8386dc"></a><!-- doxytag: member="Ogre::EdgeListBuilder::VertexDataList" ref="54baa37e788c26e4017fdef47c8386dc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a>*&gt; <a class="el" href="classOgre_1_1EdgeListBuilder.html#54baa37e788c26e4017fdef47c8386dc">Ogre::EdgeListBuilder::VertexDataList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00232">232</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="78243f2c2c6a3cbe263b6c6d802ccf75"></a><!-- doxytag: member="Ogre::EdgeListBuilder::GeometryList" ref="78243f2c2c6a3cbe263b6c6d802ccf75" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a>&gt; <a class="el" href="classOgre_1_1EdgeListBuilder.html#78243f2c2c6a3cbe263b6c6d802ccf75">Ogre::EdgeListBuilder::GeometryList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00233">233</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="792974e67a72693e08c7a3c45ca4e06c"></a><!-- doxytag: member="Ogre::EdgeListBuilder::CommonVertexList" ref="792974e67a72693e08c7a3c45ca4e06c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html">CommonVertex</a>&gt; <a class="el" href="classOgre_1_1EdgeListBuilder.html#792974e67a72693e08c7a3c45ca4e06c">Ogre::EdgeListBuilder::CommonVertexList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00234">234</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="41ee224abb216f7c8bc5261609049d19"></a><!-- doxytag: member="Ogre::EdgeListBuilder::CommonVertexMap" ref="41ee224abb216f7c8bc5261609049d19" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="classOgre_1_1Vector3.html">Vector3</a>, size_t, <a class="el" href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html">vectorLess</a>&gt; <a class="el" href="classOgre_1_1EdgeListBuilder.html#41ee224abb216f7c8bc5261609049d19">Ogre::EdgeListBuilder::CommonVertexMap</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Map for identifying common vertices. 
<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00241">241</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="76064f6b787a7b561cfac42c32d15879"></a><!-- doxytag: member="Ogre::EdgeListBuilder::EdgeMap" ref="76064f6b787a7b561cfac42c32d15879" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::multimap&lt; std::pair&lt;size_t, size_t&gt;, std::pair&lt;size_t, size_t&gt; &gt; <a class="el" href="classOgre_1_1EdgeListBuilder.html#76064f6b787a7b561cfac42c32d15879">Ogre::EdgeListBuilder::EdgeMap</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Edge map, used to connect edges. 
<p>
Note we allow many triangles on an edge, after connected an existing edge, we will remove it and never used again. 
<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00246">246</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="cf52bd519947f6f8305df1bec3247dd2"></a><!-- doxytag: member="Ogre::EdgeListBuilder::EdgeListBuilder" ref="cf52bd519947f6f8305df1bec3247dd2" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::EdgeListBuilder::EdgeListBuilder           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="f699fd3c27f017e3625b93182dfba122"></a><!-- doxytag: member="Ogre::EdgeListBuilder::~EdgeListBuilder" ref="f699fd3c27f017e3625b93182dfba122" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::EdgeListBuilder::~EdgeListBuilder           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="9845e2f91660819164a627c661f5d107"></a><!-- doxytag: member="Ogre::EdgeListBuilder::addVertexData" ref="9845e2f91660819164a627c661f5d107" args="(const VertexData *vertexData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::EdgeListBuilder::addVertexData           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td>
          <td class="paramname"> <em>vertexData</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Add a set of vertex geometry data to the edge builder. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You must add at least one set of vertex data to the builder before invoking the build method. </dd></dl>

</div>
</div><p>
<a class="anchor" name="e4af3550dfe4948680078a087377bfbf"></a><!-- doxytag: member="Ogre::EdgeListBuilder::addIndexData" ref="e4af3550dfe4948680078a087377bfbf" args="(const IndexData *indexData, size_t vertexSet=0, RenderOperation::OperationType opType=RenderOperation::OT_TRIANGLE_LIST)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::EdgeListBuilder::addIndexData           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&nbsp;</td>
          <td class="paramname"> <em>indexData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertexSet</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RenderOperation.html#7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a>&nbsp;</td>
          <td class="paramname"> <em>opType</em> = <code>RenderOperation::OT_TRIANGLE_LIST</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Add a set of index geometry data to the edge builder. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You must add at least one set of index data to the builder before invoking the build method. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>indexData</em>&nbsp;</td><td>The index information which describes the triangles. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>vertexSet</em>&nbsp;</td><td>The vertex data set this index data refers to; you only need to alter this if you have added multiple sets of vertices </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>opType</em>&nbsp;</td><td>The operation type used to render these indexes. Only triangle types are supported (no point or line types) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="7233d617fe953b3b6c74035636f1d9f0"></a><!-- doxytag: member="Ogre::EdgeListBuilder::build" ref="7233d617fe953b3b6c74035636f1d9f0" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a>* Ogre::EdgeListBuilder::build           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Builds the edge information based on the information built up so far. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The caller takes responsibility for deleting the returned structure. </dd></dl>

</div>
</div><p>
<a class="anchor" name="66aa1d48de5385be8233c8733af99186"></a><!-- doxytag: member="Ogre::EdgeListBuilder::log" ref="66aa1d48de5385be8233c8733af99186" args="(Log *l)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::EdgeListBuilder::log           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Log.html">Log</a> *&nbsp;</td>
          <td class="paramname"> <em>l</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Debugging method. 
<p>

</div>
</div><p>
<a class="anchor" name="931b3ad77134a61a22a64492fdb898bf"></a><!-- doxytag: member="Ogre::EdgeListBuilder::buildTrianglesEdges" ref="931b3ad77134a61a22a64492fdb898bf" args="(const Geometry &amp;geometry)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::EdgeListBuilder::buildTrianglesEdges           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>geometry</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="dfa93b810bd70c02bc04899851677e52"></a><!-- doxytag: member="Ogre::EdgeListBuilder::findOrCreateCommonVertex" ref="dfa93b810bd70c02bc04899851677e52" args="(const Vector3 &amp;vec, size_t vertexSet, size_t indexSet, size_t originalIndex)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::EdgeListBuilder::findOrCreateCommonVertex           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>vec</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertexSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>indexSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>originalIndex</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Finds an existing common vertex, or inserts a new one. 
<p>

</div>
</div><p>
<a class="anchor" name="5ea7b21ba4d92d2d9a73c0ac8e2d11ce"></a><!-- doxytag: member="Ogre::EdgeListBuilder::connectOrCreateEdge" ref="5ea7b21ba4d92d2d9a73c0ac8e2d11ce" args="(size_t vertexSet, size_t triangleIndex, size_t vertIndex0, size_t vertIndex1, size_t sharedVertIndex0, size_t sharedVertIndex1)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::EdgeListBuilder::connectOrCreateEdge           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertexSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>triangleIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertIndex0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertIndex1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>sharedVertIndex0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>sharedVertIndex1</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Connect existing edge or create a new edge - utility method during building. 
<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="5d4989a248aa1f8fc2f42d278aa708f0"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mGeometryList" ref="5d4989a248aa1f8fc2f42d278aa708f0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#78243f2c2c6a3cbe263b6c6d802ccf75">GeometryList</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#5d4989a248aa1f8fc2f42d278aa708f0">Ogre::EdgeListBuilder::mGeometryList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00236">236</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c706c9ac2d689aa08556ba824386c97a"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mVertexDataList" ref="c706c9ac2d689aa08556ba824386c97a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#54baa37e788c26e4017fdef47c8386dc">VertexDataList</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#c706c9ac2d689aa08556ba824386c97a">Ogre::EdgeListBuilder::mVertexDataList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00237">237</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2b2c21a40cd9ce67461bd0164fe67a35"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mVertices" ref="2b2c21a40cd9ce67461bd0164fe67a35" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#792974e67a72693e08c7a3c45ca4e06c">CommonVertexList</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#2b2c21a40cd9ce67461bd0164fe67a35">Ogre::EdgeListBuilder::mVertices</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00238">238</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8cc80f94959971521a82cc930cac46e9"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mEdgeData" ref="8cc80f94959971521a82cc930cac46e9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a>* <a class="el" href="classOgre_1_1EdgeListBuilder.html#8cc80f94959971521a82cc930cac46e9">Ogre::EdgeListBuilder::mEdgeData</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00239">239</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="43c5862bbe8afebf7ca473fbcbf219e0"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mCommonVertexMap" ref="43c5862bbe8afebf7ca473fbcbf219e0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#41ee224abb216f7c8bc5261609049d19">CommonVertexMap</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#43c5862bbe8afebf7ca473fbcbf219e0">Ogre::EdgeListBuilder::mCommonVertexMap</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00242">242</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="49964dbb7e73349bed694df63ec9b372"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mEdgeMap" ref="49964dbb7e73349bed694df63ec9b372" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#76064f6b787a7b561cfac42c32d15879">EdgeMap</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#49964dbb7e73349bed694df63ec9b372">Ogre::EdgeListBuilder::mEdgeMap</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h-source.html#l00247">247</a> of file <a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreEdgeListBuilder_8h-source.html">OgreEdgeListBuilder.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:33 2008
</p>
</body>
</html>
